<?php

/**
 * GepSituacao
 *
 * This class has been auto-generated by the Doctrine ORM Framework
 *
 * @package    DbModel
 * @subpackage Model
 * @author     jorgefonseca - 24/02/2011 15:04:35 <development@setforms.com>
 * @version    Release: SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage $
 */
class GepSituacao extends DaoGepSituacao
{
    /**
     * Consulta dados da situacao informada pelo operador.
     *
     * @param integer $nrorg       Numero da organizacao.
     * @param integer $nrsituacao  Numero da situacao.
     * @param integer $nrtipofluxo Numero do tipo de fluxo.
     *
     * @return Ambigous <mixed, NULL>|NULL
     */
    public static function buscaGepSituacao($nrorg, $nrsituacao, $nrtipofluxo) {
        try {
            $obj = self::getObjectByWhere(
                'NRORG = ? AND NRSITUACAO = ? AND NRTIPOFLUXO = ?',
                array(
                 $nrorg,
                 $nrsituacao,
                 $nrtipofluxo,
                )
            );
            return $obj;
        } catch (Exception $e) {
            return null;
        }
    }

    /**
     * Retorna os possiveis parceiros responsaveis pela situacao.
     *
     * @param integer $nrorg       Numero da Organizacao.
     * @param integer $situacao    Numero da situacao.
     * @param integer $parceiro    Numero do Parceiro.
     * @param integer $solicitacao Numero da Solicitacao.
     *
     * @return array
     */
    public static function retornaParcRespTramitacao($nrorg, $situacao, $parceiro, $solicitacao){
        $sql = self::retornaSqlParcRespTramitacao($nrorg, $situacao, $parceiro, $solicitacao);
        $result = \Setforms2\Runtime\Connection::getInstance()->fetchAll($sql);
        return $result;
    }

     /**
     * Retorna o SQL com os possiveis parceiros responsaveis pela situacao.
     *
     * @param integer $nrorg       Numero da Organizacao.
     * @param integer $situacao    Numero da situacao.
     * @param integer $parceiro    Numero do Parceiro.
     * @param integer $solicitacao Numero da Solicitacao.
     *
     * @return string
     */
    public static function retornaSqlParcRespTramitacao($nrorg, $situacao, $parceiro, $solicitacao){
        if (empty($parceiro) === true) {
           $parceiro = -1;
        }
        $sql = "SELECT NRPARCNEGOCIO, NMPRINCIPALPARC, NRORG
                  FROM (SELECT PN.NRPARCNEGOCIO, PN.NMPRINCIPALPARC, PN.NRORG
                          FROM PARCNEGOCIO PN, OPERADOR OP, OPERCLIE OC, CLIENTE CL, GEP_SITUACAO SI
                         WHERE SI.NRSITUACAO = $situacao
                           AND SI.NRORG = $nrorg
                           AND SI.DSRESPONSASITU LIKE '%OPERPARCEIROSOLI%'
                           AND CL.NRPARCNEGOCIO = $parceiro
                           AND CL.NRORG = SI.NRORG
                           AND OC.CDCLIENTE = CL.CDCLIENTE
                           AND OC.NRORG = CL.NRORG
                           AND OC.IDTPOPERCLIE = 'C'
                           AND OP.CDOPERADOR = OC.CDOPERADOR
                           AND OP.NRORG = OC.NRORG
                           AND PN.NRPARCNEGOCIO = OP.NRPARCNEGOCIO
                           AND PN.NRORG = OP.NRORG
                           AND PN.IDATIVO = 'S'
                         UNION
                        SELECT PN.NRPARCNEGOCIO, PN.NMPRINCIPALPARC, PN.NRORG
                          FROM PARCNEGOCIO PN, OPERADOR OP, OPERCLIE OC, CLIENTE CL, GEP_SITUACAO SI
                         WHERE SI.NRSITUACAO = $situacao
                           AND SI.NRORG = $nrorg
                           AND SI.DSRESPONSASITU LIKE '%OPERRESPONSAPARC%'
                           AND CL.NRPARCNEGOCIO = $parceiro
                           AND CL.NRORG = SI.NRORG
                           AND OC.CDCLIENTE = CL.CDCLIENTE
                           AND OC.NRORG = CL.NRORG
                           AND OC.IDTPOPERCLIE = 'R'
                           AND OP.CDOPERADOR = OC.CDOPERADOR
                           AND OP.NRORG = OC.NRORG
                           AND PN.NRPARCNEGOCIO = OP.NRPARCNEGOCIO
                           AND PN.IDATIVO = 'S'
                           AND PN.NRORG = OP.NRORG
                         UNION
                        SELECT DISTINCT PN.NRPARCNEGOCIO, PN.NMPRINCIPALPARC, PN.NRORG
                          FROM PARCNEGOCIO PN, OPERADOR OP, EQUIPETRAB EQ, PRODUTO PR, GEP_PRODUTOSOLI PS, GEP_SITUACAO SI
                         WHERE SI.NRSITUACAO = $situacao
                           AND SI.NRORG = $nrorg
                           AND SI.DSRESPONSASITU LIKE '%OPERRESPONSAPROD%'
                           AND PS.NRSOLICITACAO = $solicitacao
                           AND PS.NRORG = SI.NRORG
                           AND PR.CDPRODUTO = PS.CDPRODUTO
                           AND PR.NRORG = PS.NRORG
                           AND EQ.CDEQUIPETRAB = PR.CDEQUIPERESP
                           AND EQ.NRORG = PR.NRORG
                           AND OP.CDOPERADOR = EQ.CDOPERRESP
                           AND OP.NRORG = EQ.NRORG
                           AND PN.NRPARCNEGOCIO = OP.NRPARCNEGOCIO
                           AND PN.NRORG = OP.NRORG
                           AND PN.IDATIVO = 'S'
                         UNION
                        SELECT DISTINCT PN.NRPARCNEGOCIO, PN.NMPRINCIPALPARC, PN.NRORG
                          FROM PARCNEGOCIO PN, GEP_OPERRESPONSAPROD OP, GEP_PRODUTOSOLI PS, GEP_SITUACAO SI
                         WHERE SI.NRSITUACAO = $situacao
                           AND SI.NRORG = $nrorg
                           AND SI.DSRESPONSASITU LIKE '%OPERRESPONSAPROD%'
                           AND PS.NRSOLICITACAO = $solicitacao
                           AND PS.NRORG = SI.NRORG
                           AND OP.CDPRODUTO = PS.CDPRODUTO
                           AND OP.NRORG = PS.NRORG
                           AND PN.NRPARCNEGOCIO = OP.NRPARCOPERRESP
                           AND PN.NRORG = OP.NRORG
                           AND PN.IDATIVO = 'S'
                         UNION
                        SELECT PN.NRPARCNEGOCIO, PN.NMPRINCIPALPARC, PN.NRORG
                          FROM PARCNEGOCIO PN, PARCERIA PA, GEP_SITUACAO SI
                         WHERE SI.NRSITUACAO = $situacao
                           AND SI.NRORG = $nrorg
                           AND SI.DSRESPONSASITU LIKE '%OPERFUNCIONARIO%'
                           AND PA.CDTIPOPARCEIRO = 'FUNCIONARIO'
                           AND PA.NRORG = SI.NRORG
                           AND PN.NRPARCNEGOCIO = PA.NRPARCNEGOCIO
                           AND PN.NRORG = PA.NRORG
                           AND PN.IDATIVO = 'S'
                         UNION
                        SELECT PN.NRPARCNEGOCIO, PN.NMPRINCIPALPARC, PN.NRORG
                          FROM PARCNEGOCIO PN, GEP_OPERSITUACAO OS, GEP_SITUACAO SI
                         WHERE SI.NRSITUACAO = $situacao
                           AND SI.NRORG = $nrorg
                           AND SI.DSRESPONSASITU LIKE '%LISTAOPERADOR%'
                           AND OS.NRSITUACAO = SI.NRSITUACAO
                           AND OS.NRORG = SI.NRORG
                           AND PN.NRPARCNEGOCIO = OS.NRPARCOPERADOR
                           AND PN.NRORG = OS.NRORG
                           AND PN.IDATIVO = 'S'
                         UNION
                        SELECT PN.NRPARCNEGOCIO, PN.NMPRINCIPALPARC, PN.NRORG
                          FROM PARCNEGOCIO PN, PERFACESSPARC PP, GEP_PERFILSITUACAO PS, GEP_SITUACAO SI
                         WHERE SI.NRSITUACAO = $situacao
                           AND SI.NRORG = $nrorg
                           AND SI.DSRESPONSASITU LIKE '%LISTAPERFILACESS%'
                           AND PS.NRSITUACAO = SI.NRSITUACAO
                           AND PS.NRORG = SI.NRORG
                           AND PP.NRPERFILACESSO = PS.NRPERFILACESSO
                           AND PP.NRORG = PS.NRORG
                           AND PN.NRPARCNEGOCIO = PP.NRPARCNEGOCIO
                           AND PN.IDATIVO = 'S'
                           AND PN.NRORG = PP.NRORG)
                 ORDER BY NMPRINCIPALPARC";
        return $sql;
    }

    /**
     * Consulta as situcoes parametrizadas para determinado tipo de fluxo.
     *
     * @param integer $nrorg       Numero da organizacao.
     * @param integer $nrtipofluxo Numero do tipo de fluxo.
     *
     * @return array $obj          Resultado da consulta.
     */
    public static function consultaSituacaoPorTipoFluxo($nrorg, $nrtipofluxo) {
        try {
            $obj = self::getObjectsByWhere(
                'NRORG = ? AND NRTIPOFLUXO = ?',
                array(
                 $nrorg,
                 $nrtipofluxo,
                )
            );
            return $obj;
        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return null;
        }
}

    /**
     * Consulta Perfis de acesso responsiveis por uma determinada situcao.
     *
     * @param integer $nrorg    Numero da Organizacao.
     * @param integer $situacao Numero da Situacao.
     *
     * @return string
     */
    public static function sqlPerfilAcessoSituacao($nrorg, $situacao){
        $sql = "SELECT PA.NRPERFILACESSO,
                       PA.NMPERFILACESSO,
                       PA.NRORG
                  FROM PERFILACESSO PA, GEP_PERFILSITUACAO PS, GEP_SITUACAO SI
                 WHERE SI.NRSITUACAO = $situacao
                   AND SI.NRORG = $nrorg
                   AND SI.DSRESPONSASITU LIKE '%LISTAPERFILACESS%' -- LISTA DE PERFIS DE ACESSO
                   AND PS.NRSITUACAO = SI.NRSITUACAO
                   AND PS.NRORG = SI.NRORG
                   AND PA.NRPERFILACESSO = PS.NRPERFILACESSO
                   AND PA.NRORG = PS.NRORG";
        return $sql;
    }
}