package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;

import org.openqa.selenium.By;
import org.testng.Assert;

public class MainPage extends PageBase {

    //Mapping
    By usernameLoginInfoTextArea = By.xpath("//*[@class = 'navbar-brand zh-header-title has-header-info']");
    By msgConfirmaTela = By.xpath("//div[@class = 'navbar-brand zh-header-title has-header-info']");
    By botaoInicial = By.xpath("//*[@type = 'button']");
    By displayInicio = By.xpath("//*[@type = 'button']");
    By clicarBotao = By.xpath("//*[@class = 'menu-link'] //*[contains(text(),'Parametrização')]");

    By clicaPlanejamento = By.xpath("//ul[@class = 'sub-menu']//*[contains(text(),'Planejamento')]");

    By clicaEmPrato = By.xpath("//ul[@class = 'sub-menu']//li[@class = 'menu-item closed sub-menu-item has-child visible']//span[@class = 'menu-link']//*[contains(text(),'Prato')]");
    By clicaGrupoTipoPrato = By.xpath("//ul[@class = 'sub-menu']//li[@ng-repeat='menu in _menu.menus']//span[@class = 'menu-link']//*[contains(text(),'Grupo de Tipo de Prato')]");
    By botaoAdicionar = By.xpath("//*[@id='footer']/div[2]/ul/li[1]");
    By codigoGrupo = By.xpath("//*[@id = 'CDGRTIPOPR']");
    By nomeGrupo   = By.xpath("//*[@id = 'NMGRTIPOPR']");
    By botaoSalvar = By.xpath("//span[contains(text(),'Salvar')]");
    By loadingWait = By.xpath("//*[@class='zh-background-loading ng-scope']//span[@class='zh-loading-icon']");



    //Actions
    public String retornaUsernameDasInformacoesDeLogin() {
        return getText(usernameLoginInfoTextArea);
    }

    public String retornaMensagemTela(){
    return getText(msgConfirmaTela);

    }

    public void clicarEmMenuPrincipal() {

        waitForElement(displayInicio);
        waitForElement(usernameLoginInfoTextArea);
        click(botaoInicial);
    }

    public void clicarEmPParametrizacao() {

       // waitForElement(displayInicio);
      //  waitForElement(usernameLoginInfoTextArea);
        click(clicarBotao);


    }

    public void clicarEmPlanejamento(){
      //  waitForElement(btnMedicao);
        click(clicaPlanejamento);
    }

    public void clicarEmPrato(){
        waitForVisibilityOfElementLocated(clicaEmPrato);
        click(clicaEmPrato);
    }

    public void clicarGrupoTipodePrato(){
        waitForVisibilityOfElementLocated(clicaGrupoTipoPrato);
        click(clicaGrupoTipoPrato);
    }

    public void clicaAdicionar(){//*[@id='footer']/div[2]/ul/li[1]/a/span[1]
        waitForElement(botaoAdicionar);
        click(botaoAdicionar);
        //  sendKeys(filtroUnidade, unidade);

    }

    public void informarCodigo(String codigo){
        //clickWithoutClickable(filtroUnidade);
        click(codigoGrupo);
        sendKeys(codigoGrupo, codigo);
    }

    public void informaNomeGrupo(String nome){
        click(nomeGrupo);
        sendKeys(nomeGrupo, nome);
    }



    public void salvaInformacao() {
        try {
            click(botaoSalvar);
            if ("Impossível adicionar. Registro já existe.".equals(driver.findElement(By.xpath("//*[@class = 'zh-container-alert']//*[contains(text(),'Impossível adicionar. Registro já existe.')]")).getText())) {
                System.out.println("Item já cadastrado.");

            } else {
                System.out.println("Item cadastrado com sucesso.");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

    }



}


